﻿Type=Class
Version=2.5
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Type pager(heading, topic, body As String)
	Private page As pager
	
	Private  HelpPnl, btnpnl As Panel
	Private scvHelp As ScrollView
	Private Helplbl1, Helplbl2, Helplbl3 As Label
	Private helpindex, helpindexmax, bpos As Int
	Private btnHelpPrev, btnHelpFirst, btnHelpNext, BtnHelpLast, btnHelpOK  As Button
	Private aWidth, aHeight As Int
	Private bcolor, tcolor, hcolor, tpcolor As Int
	Private landscape As Boolean
	Private su As StringUtils
	Private fdir As String
	Private act As Activity
	Public CurPage As Int
	
End Sub

'Initializes the object. Activity is the activity calling initialize and should be Activity.
'Top tells the reader where to put the buttons. If Top is True they will appear at the top. False puts them at the bottom.
'bgColor is the background color
'txtColor is the text color
'headingColor is the color of the page heading (1st line of file)
'topicColor is the color of the Topic (2nd line of file)
'fileDir is where the help files are stored
Public Sub Initialize(A As activity, Top As Boolean, bgColor As Int, txtColor As Int, headingColor As Int, topicColor As Int, fileDir As String)
	Dim lst As List
	Dim i, hc As Int
	Dim tst As String
	
	act = A
	
	aHeight = act.Height
	aWidth = act.Width
	fdir = fileDir
	
	helpindex = 0
	
	lst = File.ListFiles(fdir)
	hc = 0
	
	For  i = 0 To lst.Size - 1
	tst = lst.get(i)
	
	If tst.StartsWith("help") Then
	hc = hc + 1
	End If
	
	Next
	
	helpindexmax = hc - 1
	
	bcolor = bgColor
	tcolor = txtColor
	hcolor = headingColor
	tpcolor = topicColor
	
	If Not(fdir.EndsWith("/")) AND Not(fdir = "AssetsDir")Then
	fdir = fdir & "/"
	End If
		
	HelpPnl.Initialize("")
	btnpnl.Initialize("")
	
	act.AddView(HelpPnl, 0, 0, aWidth, aHeight)
	
	HelpPnl.Width = aWidth
	HelpPnl.Height = aHeight
	HelpPnl.Color = bcolor
	
	scvHelp.Initialize(4000)
	
	landscape = (aWidth > aHeight)
	
	If Top Then 
	bpos = 0
	Else
	bpos = aHeight - 40dip
	End If
	
	InitHelp
	
End Sub

Private Sub InitHelp
		
	HelpPnl.Top = 0
	HelpPnl.Left = 0
	HelpPnl.Height = aHeight
	HelpPnl.Width = aWidth
	
	btnHelpFirst.Initialize("btnhelpmove")
	btnHelpPrev.Initialize("btnhelpmove")
	btnHelpNext.Initialize("btnhelpmove")
	BtnHelpLast.Initialize("btnhelpmove")
	btnHelpOK.Initialize("btnhelpok")
	
	btnHelpFirst.Text = "|<<"
	btnHelpFirst.Tag = "First"
	btnHelpFirst.TextSize = 20
	
	btnHelpPrev.Text = "<"
	btnHelpPrev.Tag = "Prev"
	btnHelpPrev.TextSize = 20
	
	btnHelpNext.Text = ">"
	btnHelpNext.Tag = "Next"
	btnHelpNext.TextSize = 20
	
	BtnHelpLast.Text = ">>|"
	BtnHelpLast.Tag = "Last"
	BtnHelpLast.TextSize = 20
	
	btnHelpOK.Text = "Exit"
	btnHelpFirst.TextSize = 18
	
	btnpnl.AddView(btnHelpFirst, 0, 0, 60dip, 40dip)
	btnpnl.AddView(btnHelpPrev, 65dip, 0, 60dip, 40dip)
	btnpnl.AddView(btnHelpNext, 130dip, 0, 60dip, 40dip)
	btnpnl.AddView(BtnHelpLast, 195dip, 0, 60dip, 40dip)
	btnpnl.AddView(btnHelpOK, HelpPnl.Width - 60dip - 5dip, 0, 60dip, 40dip)
	btnpnl.Color = Colors.LightGray
	
	If bpos = 0 Then
	HelpPnl.AddView(btnpnl, 0, 0, 100%x, 40dip)
	HelpPnl.AddView(scvHelp, 0, 45dip, aWidth, aHeight - 45dip)
	Else
	HelpPnl.AddView(scvHelp, 0, 0, aWidth, aHeight - 45dip)
	HelpPnl.AddView(btnpnl, 0, aHeight - 40dip, 100%x, 40dip)
	End If
	
	btnHelpFirst.Color = Colors.RGB(210,180,140)
	btnHelpPrev.Color = Colors.RGB(210,180,140)
	btnHelpNext.Color = Colors.RGB(210,180,140)
	BtnHelpLast.Color = Colors.RGB(210,180,140)
	btnHelpOK.Color = Colors.Green
	
	scvHelp.Panel.Width = scvHelp.Width
	scvHelp.Panel.Color = bcolor
	
	btnHelpOK.Left = scvHelp.Width - btnHelpOK.Width - 5dip
	
	Helplbl1.Initialize("")
	Helplbl2.Initialize("")
	Helplbl3.Initialize("")
	
	scvHelp.Panel.AddView(Helplbl1, 0, 0, aWidth - 20dip, 60dip)
	scvHelp.Panel.AddView(Helplbl2, 0, 60dip, aWidth, 60dip)
	scvHelp.Panel.AddView(Helplbl3, 0, 120dip, aWidth, 40dip)
	
	Helplbl1.Top = 0
	Helplbl1.Gravity = Gravity.CENTER
	Helplbl1.TextColor = hcolor
	Helplbl1.TextSize = 20
	
	Helplbl2.Top = 60dip
	Helplbl2.Gravity = Gravity.LEFT
	Helplbl2.TextColor = tpcolor
	Helplbl2.TextSize = 20
	
	Helplbl3.Top = 120dip
'	Helplbl3.Height = -2
	Helplbl3.TextColor = tcolor
	Helplbl3.TextSize = 18
	
	DisplayHelp
	
End Sub

Private Sub getpage(pagenum As Int)
	Dim reader As TextReader
	
	reader.Initialize(File.OpenInput(fdir,"help"&pagenum&".txt"))
	page.heading = reader.ReadLine
	page.topic = reader.ReadLine
	page.body = reader.ReadAll
	reader.Close
	
End Sub

Private Sub DisplayHelp
	Dim hgt As Double
	Dim gi As Int
	
	scvHelp.ScrollPosition = 0
	hgt = 0
	
	If helpindex <= 0 Then
	helpindex = 0
		btnHelpPrev.Enabled = False
		btnHelpFirst.Enabled = False
		Else
		btnHelpPrev.Enabled = True
		btnHelpFirst.Enabled = True
	End If
		
	If helpindex >= helpindexmax Then
	helpindex = helpindexmax
		btnHelpNext.Enabled = False
		BtnHelpLast.Enabled = False
		Else
		btnHelpNext.Enabled = True
		BtnHelpLast.Enabled = True
	End If
	
	getpage(helpindex)
	CurPage = helpindex
	
	Helplbl1.Height = 60dip
	Helplbl1.Text = page.heading
	
	Helplbl2.Height = 60dip
	Helplbl2.Text = page.topic
	
'	Helplbl3.Height = -2
	If page.topic = "" Then
	Helplbl3.Top = 60dip
	Helplbl2.Height = 1dip
	Else
	Helplbl3.Top = 120dip
	End If
	
	Helplbl3.Height = -2
	Helplbl3.Text = page.body
	Helplbl3.Left = 10dip
	Helplbl3.Width = aWidth - 20dip
	
	hgt = su.MeasureMultilineTextHeight(Helplbl3, Helplbl3.Text)  + (Helplbl1.Height + Helplbl2.Height)
	
	If hgt > scvHelp.Height Then
	scvHelp.Panel.Height = hgt
	gi = scvHelp.Panel.Height
	scvHelp.FullScroll(False)
	DoEvents
	Else
	scvHelp.Panel.Height = scvHelp.Height
	Helplbl3.Height = scvHelp.Height
	DoEvents
	End If
	
End Sub

'Shows the help reader. You do NOT need to call this method after calling Initialize. The reader will display as soon as it is initialized the first time. Use this to redisplay the help at any time.
Public Sub ShowHelp
	
	HelpPnl.BringToFront
	HelpPnl.Visible = True
	
	DisplayHelp
	
End Sub

'Allows you to jump to another help page. 
'Each "page" is actually a file, so passing 4 will display help4.txt.
Public Sub ShowPage(pagenum As Int)
	
	If pagenum > helpindexmax Then
	Return
	End If
	
	If Not(HelpShowing) Then
	HelpPnl.BringToFront
	HelpPnl.Visible = True
	End If
	
	helpindex = pagenum
	DisplayHelp
	
End Sub

'Hides the help reader form view. It remains initialized so you can call ShowHelp any time you need.
Public Sub HideHelp
	
	HelpPnl.Visible = False
	HelpPnl.SendToBack
	
End Sub

Private Sub btnHelpOK_Click
	
	HideHelp
	
End Sub

Private Sub btnHelpMove_Click
' help button maganement

	Dim send As View
	Dim btn  As String
	
	send = Sender
	btn = send.Tag
	
	If helpindex > 0 AND btn = "Prev" Then
		helpindex = helpindex - 1
	Else If helpindex < helpindexmax AND btn = "Next" Then
		helpindex = helpindex + 1
	Else If btn = "First" Then
		helpindex = 0
	Else If btn = "Last" Then
		helpindex = helpindexmax
	End If

	If helpindex = 0 Then
		btnHelpPrev.Enabled = False
		btnHelpFirst.Enabled = False
	Else
		btnHelpPrev.Enabled = True
		btnHelpFirst.Enabled = True
	End If

	If helpindex = helpindexmax Then
		btnHelpNext.Enabled = False
		BtnHelpLast.Enabled = False
	Else
		btnHelpNext.Enabled = True
		BtnHelpLast.Enabled = True
	End If

	DisplayHelp
	
End Sub

'Returns True if the help reader is currently visible on the screen.
Public Sub HelpShowing As Boolean
	
	Return HelpPnl.Visible
	
End Sub
